package com.sa.ibiz.demo.demoapp.controller.demo;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.sql.Timestamp;
import javax.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.sa.ibiz.demo.ibizutil.domain.ActionResult;
import com.sa.ibiz.demo.demo.service.UniResService;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import com.sa.ibiz.demo.demo.domain.UniRes;
import com.sa.ibiz.demo.demo.service.dto.UniResSearchFilter;
import com.sa.ibiz.demo.demoapp.controller.demo.vo.*;
import org.springframework.cglib.beans.BeanGenerator;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.util.StringUtils;
import java.io.IOException;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.validation.annotation.Validated;
import org.springframework.http.ResponseEntity;
import org.springframework.beans.factory.annotation.Autowired;
import com.sa.ibiz.demo.ibizutil.domain.RedirectResult;
import javax.validation.constraints.NotBlank;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@RestController
@RequestMapping("/demoapp/demo/unires")
public class UniResController{



    @Autowired
	private UniResService uniresService;
	/**
	 * 获取服务对象
	*/
	protected UniResService getService(){
		return this.uniresService;
	}



	@PostMapping(value="maineditform/update")
	public ResponseEntity<UniRes_EditForm_Main> mainEditFormUpdate(@Validated @RequestBody UniRes_EditForm_Main form){
            UniRes entity =form.toUniRes();
            getService().update(entity);
            form.fromUniRes(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="maineditform/remove")
	public ResponseEntity<UniRes_EditForm_Main> mainEditFormRemove(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UniRes_EditForm_Main form=new UniRes_EditForm_Main();
            UniRes entity = new UniRes();
            entity.setUniresid(srfkey);
            getService().remove(entity);
            form.setSrfuf("0");
            form.fromUniRes(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maineditform/getdraft")
	public ResponseEntity<UniRes_EditForm_Main> mainEditFormGetDraft(@RequestBody UniRes_EditForm_Main form){
        if(!StringUtils.isEmpty(form.getSrfsourcekey()))
        {
            UniRes sourceEntity =new UniRes();
            sourceEntity.setUniresid(form.getSrfsourcekey());
            this.getService().get(sourceEntity);

			UniRes targetEntity =new UniRes();
			sourceEntity.copyTo(targetEntity);
			form.fromUniRes(targetEntity,false);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
         }
            UniRes entity =form.toUniRes();
            getService().getDraft(entity);
            form.fromUniRes(entity);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="maineditform/get")
	public ResponseEntity<UniRes_EditForm_Main> mainEditFormGet(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UniRes_EditForm_Main form=new UniRes_EditForm_Main();
            UniRes entity = new UniRes();
            entity.setUniresid(srfkey);
            entity=getService().get(entity);
            form.setSrfuf("1");
            form.fromUniRes(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maineditform/create")
	public ResponseEntity<UniRes_EditForm_Main> mainEditFormCreate(@Validated @RequestBody UniRes_EditForm_Main form){
            UniRes entity =form.toUniRes();
            getService().create(entity);
            form.fromUniRes(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maingrid/update")
	public UniRes mainGridUpdate(@Validated UniRes mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/remove")
	public ResponseEntity<UniRes> mainGridRemove(@Validated @RequestBody Map args){
	    UniRes entity =new UniRes();
	    if ( !StringUtils.isEmpty(args.get("srfkeys"))) {
			String srfkeys=args.get("srfkeys").toString();
			String srfkeyArr[] =srfkeys.split(";");
			for(String srfkey : srfkeyArr)
			{
				if(!StringUtils.isEmpty(srfkey)){
				entity.setUniresid(srfkey);
				this.getService().remove(entity);
                }
            }
        }
		return ResponseEntity.ok().body(entity);
	}
	public UniRes mainGridGet(String uniresid){
		return null;
	}
	@PostMapping(value="maingrid/getdraft")
	public UniRes mainGridGetDraft(@Validated UniRes mainItem){
		return mainItem;
	}
	@PostMapping(value="maingrid/create")
	public UniRes mainGridCreate(@Validated UniRes mainItem){
		return mainItem;
	}
	@org.springframework.beans.factory.annotation.Value("${ibiz.filePath}")
    private String strFilePath;
	@Autowired
    private com.sa.ibiz.demo.ibizutil.service.IBZFILEService ibzfileService;
	/**
	 * [main]表格数据导出
	 * @param searchFilter
	 * @return
	 * @throws
	 * @throws
	 */
	@PostMapping(value="maingrid/exportdata/searchdefault")
	public ResponseEntity<Page<JSONObject>> maingridExportDataSearchDefault(@Validated @RequestBody UniResSearchFilter searchFilter) throws IOException, jxl.write.WriteException {
		String fileid=com.baomidou.mybatisplus.core.toolkit.IdWorker.get32UUID();
		String localPath=ExportDataInit(fileid);//输出文件相对路径
		Page<UniRes> searchResult = this.getService().searchDefault(searchFilter);//1.查询表格数据
		List<Map<String,Object>> datas=UniRes_Grid_Main.pageToListDatas(searchResult);//2.将数据转换成list
		List<Map<String,String>> colnums=UniRes_Grid_Main.getGridColumnModels();//3.获取表格列头
        java.io.File outputFile=com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.output(strFilePath+localPath,colnums,datas);//4.生成导出文件
		com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.saveFileData(outputFile,localPath,fileid,ibzfileService); //5.保存file表记录
		String strDownloadUrl =String.format("ibizutil/download/"+fileid);//6.回传文件路径给前台
        Page<JSONObject> resultObj=UniRes_Grid_Main.getResultPage(searchResult,strDownloadUrl);//7.获取输出对象
			return ResponseEntity.ok().body(resultObj);
	}
	/**
	 * 表格数据导出
	 * @param fileid
	 * @return
	 */
	private String ExportDataInit(String fileid) {
		java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("yyyyMMdd");
        String filepath=dateFormat.format(new java.util.Date())+ java.io.File.separator;
        java.text.SimpleDateFormat dateFormat2 = new java.text.SimpleDateFormat("yyyyMMddHHmmss");
		String strTempFileName = fileid+"-"+dateFormat2.format(new java.util.Date())+".xls";
		java.io.File file =new java.io.File(strFilePath+filepath);
		if(!file.exists())
           file.mkdirs();
		return filepath+strTempFileName;
	}
	@PostMapping(value="maingrid/searchdefault")
	public ResponseEntity<Page<UniRes_Grid_Main>> mainGridSearchDefault(@Validated @RequestBody UniResSearchFilter searchFilter){
			Page<UniRes> searchResult = this.getService().searchDefault(searchFilter);
			Page<UniRes_Grid_Main> searchResult_vo_data =UniRes_Grid_Main.fromUniRes(searchResult);
					return ResponseEntity.ok().body(searchResult_vo_data);
	}
	@PostMapping(value="defaultsearchform/load")
	public void defaultSearchFormLoad(){

	}
   	@PostMapping(value="defaultsearchform/loaddraft")
	public ResponseEntity<UniRes_SearchForm_Default> defaultSearchFormLoadDraft(@Validated @RequestBody UniRes_SearchForm_Default searchform){
 		 
			UniResSearchFilter searchfilter =searchform.toUniResSearchFilter();
			searchform.fromUniResSearchFilter(searchfilter);
			return ResponseEntity.ok().body(searchform);
	} 
	@PostMapping(value="defaultsearchform/search")
	public void defaultSearchFormSearch(){
			 
	} 
 }